/**
 * Chooses the correct player, but uses a wrong strategy.
 * Alessia: same as correct solution, but doesn't sort the input.
 * Bernardo: always chooses the number most distant from the closest number already chosen.
 * 
 */

#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<int> x(n + 1);
    for (int i = 1; i <= n; ++i) cin >> x[i];

    vector<int> p(n + 1);
    iota(p.begin(), p.end(), 0);
    sort(p.begin() + 1, p.end(), [&](int const& a, int const& b) {
        return x[a] > x[b];
    });

    auto xx = [&](int const& i) { return x[p[i]]; };

    int k = 0;
    for (int i = 1; i <= n; ++i) {
        if (xx(i) > m / i) {
            k = i;
            break;
        }
    }

    if (k == 0) {
        cout << "Alessia" << endl;
        vector<bool> chosen(m + 1, false);
        for (int t = 1; t <= n; ++t) {
            int y = x[t];
            int last = 0;
            int min_width = m + 1;
            int a = 1;
            for (int i = 1; i <= m; ++i) {
                if (chosen[i]) {
                    last = i;
                }
                if ((i == m || chosen[i + 1]) && i - last >= y && i - last < min_width) {
                    min_width = i - last;
                    a = last + 1;
                }
            }
            cout << y << " " << a << endl;
            int b;
            cin >> b;
            chosen[b] = true;
        }
    } else {
        cout << "Bernardo" << endl;
        vector<bool> chosen(m + 1, false);
        for (int t = 1; t <= n; ++t) {
            int y, a;
            cin >> y >> a;
            bool done = false;
            for (int i = a; i <= a + y - 1; ++i) {
                if (chosen[i]) {
                    cout << i << endl;
                    done = true;
                    break;
                }
            }
            if (!done) {
                int l = 0, r = m + 1;
                for (int i = a - 1; i > 0; --i) {
                    if (chosen[i]) {
                        l = i;
                        break;
                    }
                }
                for (int i = a + y; i <= m; ++i) {
                    if (chosen[i]) {
                        r = i;
                        break;
                    }
                }
                int h = (l + r) / 2;
                if (a <= h && h < a + y) {
                    cout << h << endl;
                } else if (a <= h) {
                    cout << a + y - 1 << endl;
                } else cout << a << endl;
            }
        }
    }

    return 0;
}
