/**
 * Identical to the optimal solution, but has an off-by-one in the condition xx(i) > m / i.
 * 
 */

#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<int> x(n + 1);
    for (int i = 1; i <= n; ++i) cin >> x[i];

    vector<int> p(n + 1);
    iota(p.begin(), p.end(), 0);
    sort(p.begin() + 1, p.end(), [&](int const& a, int const& b) {
        return x[a] > x[b];
    });

    auto xx = [&](int const& i) { return x[p[i]]; };

    int k = 0;
    for (int i = 1; i <= n; ++i) {
        if (xx(i) >= m / i) {
            k = i;
            break;
        }
    }

    if (k == 0) {
        cout << "Alessia" << endl;
        vector<bool> chosen(m + 1, false);
        for (int t = 1; t <= n; ++t) {
            int y = xx(t);
            int last = 0;
            int a = 0;
            for (int i = 1; i <= m; ++i) {
                if (chosen[i]) {
                    last = i;
                }
                if (!chosen[i] && i - last == y) {
                    a = last + 1;
                    break;
                }
            }
            cout << y << " " << a << endl;
            int b;
            cin >> b;
            chosen[b] = true;
        }
    } else {
        cout << "Bernardo" << endl;
        for (int t = 1; t <= n; ++t) {
            int y, a;
            cin >> y >> a;
            bool done = false;
            for (int i = a; i <= a + y - 1; ++i) {
                if (i % xx(k) == 0) {
                    cout << i << endl;
                    done = true;
                    break;
                }
            }
            if (!done) cout << a << endl;
        }
    }

    return 0;
}
